


SELECT * 
INTO Production.NewLocation
FROM Production.Location



CREATE TRIGGER Production.iNewLocation
ON Production.NewLocation
AFTER INSERT
AS
PRINT 'New row added to NewLocation table'


INSERT INTO Production.NewLocation (Name, 
CostRate, Availability, ModifiedDate)
VALUES ('Crash Test Certification', 
23.90, 98, GetDate())


ALTER TRIGGER Production.iNewLocation
ON Production.NewLocation
INSTEAD OF INSERT
AS
PRINT 'You cannot add new rows to NewLocation table'



INSERT INTO Production.NewLocation (Name, 
CostRate, Availability, ModifiedDate)
VALUES ('QA Testing', 
15.50, 112, GetDate())


SELECT * FROM Production.NewLocation
WHERE Name = 'QA Testing'




ALTER TABLE Production.NewLocation
ALTER COLUMN ModifiedDate datetime null


DROP TRIGGER Production.iNewLocation



CREATE TRIGGER Production.iuNewLocation ON Production.NewLocation
AFTER INSERT, UPDATE 
NOT FOR REPLICATION AS
BEGIN
    SET NOCOUNT ON
    UPDATE Production.NewLocation
    SET ModifiedDate = GETDATE()
    FROM Production.NewLocation INNER JOIN inserted
    ON Production.NewLocation.LocationID = inserted.LocationID
END 



INSERT INTO Production.NewLocation (Name, 
CostRate, Availability)
VALUES ('QA Testing', 15.50, 112)


SELECT * FROM Production.NewLocation
WHERE Name = 'QA Testing'



UPDATE Production.NewLocation
SET CostRate = 22.00
WHERE Name = 'QA Testing'




ALTER TRIGGER Production.iuNewLocation 
ON Production.NewLocation
AFTER INSERT, UPDATE 
NOT FOR REPLICATION AS
  IF UPDATE(ModifiedDate)
    RAISERROR('Do not edit the ModifiedDate column', 16, 1)
  ELSE
    BEGIN
      SET NOCOUNT ON
      UPDATE Production.NewLocation
      SET ModifiedDate = GETDATE()
      FROM Production.NewLocation INNER JOIN inserted
      ON Production.NewLocation.LocationID = inserted.LocationID
    END



UPDATE Production.NewLocation
SET ModifiedDate = GetDate()
WHERE Name = 'QA Testing'



CREATE TRIGGER ProtectObjects
ON DATABASE 
FOR DROP_TABLE, DROP_VIEW, DROP_PROCEDURE 
AS 
   PRINT 'Trigger ProtectObjects prevents dropping objects' 
   ROLLBACK


DROP TABLE Production.NewLocation



--NOTE: DROP syntax is different for DDL triggers 
-- ON DATABASE or ON ALL_SERVER must be specified
DROP TRIGGER ProtectObjects
ON DATABASE


