

CREATE TABLE Production.Material(
	MaterialID int NOT NULL,
	Name varchar(40) NOT NULL,
	InventoryLevel int NOT NULL,
	ModifiedDate datetime NULL,
 CONSTRAINT PK_Material PRIMARY KEY CLUSTERED 
 (
	MaterialID 
 )
)




CREATE TRIGGER Production.uMaterial
ON Production.Material
INSTEAD OF UPDATE
AS
PRINT 'You cannot edit the Material table'



DROP TRIGGER Production.uMaterial



CREATE TRIGGER Production.iuMaterial ON Production.Material
AFTER INSERT, UPDATE 
NOT FOR REPLICATION AS
BEGIN
    SET NOCOUNT ON
    UPDATE Production.Material
    SET ModifiedDate = GETDATE()
    FROM Production.Material INNER JOIN inserted
    ON Production.Material.MaterialID = inserted.MaterialID
END


CREATE TRIGGER Production.dMaterial ON Production.Material
AFTER DELETE 
NOT FOR REPLICATION
AS
DECLARE @inv int
SELECT @inv = Production.Material.InventoryLevel
  FROM Production.Material INNER JOIN deleted
  ON Production.Material.MaterialID = deleted.MaterialID
IF @inv > 0
BEGIN
  PRINT 'Cannot delete a row with nonzero inventory'
  ROLLBACK
END





