
USE AdventureWorks2008
GO
exec sys.sp_cdc_enable_db
GO


SELECT *
INTO Production.NewCulture
FROM Production.Culture
GO

CREATE UNIQUE INDEX IX_NewCulture_ID 
ON Production.NewCulture (CultureID) 
GO




exec sys.sp_cdc_enable_table
	@source_schema='Production',
	@source_name='NewCulture',
	@role_name=NULL
	

SELECT is_cdc_enabled 
FROM sys.databases
WHERE name = 'AdventureWorks2008';

SELECT is_tracked_by_cdc
FROM sys.tables
WHERE name='NewCulture';





INSERT INTO Production.NewCulture
(CultureID, Name, ModifiedDate)
VALUES ('sw', 'Swedish', GETDATE());

UPDATE Production.NewCulture
SET Name = 'Armenian'
WHERE CultureID = 'ar';


SELECT * FROM cdc.Production_NewCulture_CT




ALTER TABLE Production.NewCulture
ADD Descr nvarchar(255) NULL



SELECT * FROM cdc.Production_NewCulture_CT


SELECT * FROM cdc.ddl_history


UPDATE Production.NewCulture
SET Descr = 'The English Language'
WHERE CultureID = 'en'


SELECT * FROM cdc.Production_NewCulture_CT


DECLARE @from_lsn binary(10), @to_lsn binary(10)
SELECT @from_lsn = MIN(__$start_lsn) 
FROM cdc.Production_NewCulture_CT
SELECT @to_lsn = MAX(__$start_lsn) 
FROM cdc.Production_NewCulture_CT
SELECT * FROM cdc.fn_cdc_get_all_changes_Production_NewCulture
	(@from_lsn, @to_lsn, 'all update old');
	
	
	
EXECUTE sys.sp_cdc_get_ddl_history 
    @capture_instance = 'Production_NewCulture';





/*
--sample code to turn off Change Data Capture
exec sys.sp_cdc_disable_table
	@source_schema='Production',
	@source_name='NewCulture',
	@capture_instance='Production_NewCulture'
GO

exec sys.sp_cdc_disable_db
GO
*/



USE master;
GO
CREATE MASTER KEY ENCRYPTION BY PASSWORD = 'abc123!@#';
GO
CREATE CERTIFICATE AdvWksCert WITH SUBJECT = 'AdventureWorks DEK Cert'
GO
USE AdventureWorks2008
GO
CREATE DATABASE ENCRYPTION KEY
WITH ALGORITHM = AES_128
ENCRYPTION BY SERVER CERTIFICATE AdvWksCert
GO
ALTER DATABASE AdventureWorks2008
SET ENCRYPTION ON
GO




/*
-- sample code to turn off TDE
ALTER DATABASE AdventureWorks2008
SET ENCRYPTION OFF
GO
*/





