
USE master
GO
CREATE DATABASE Chapter14Exercise
GO


USE Chapter14Exercise
CREATE TABLE Contacts
(
	ContactID	int		IDENTITY(1, 1) PRIMARY KEY,
	FirstName	nvarchar(50)	NOT NULL,
	LastName	nvarchar(50)	NOT NULL,
	Email			nvarchar(50)	NOT NULL
)
GO



INSERT INTO Contacts
(FirstName, LastName, Email)
VALUES ('George', 'McHale', 'george@example.com')


EXEC sys.sp_cdc_enable_db


EXEC sys.sp_cdc_enable_table
	@source_schema='dbo',
	@source_name='Contacts',
	@role_name=NULL


INSERT INTO Contacts
(FirstName, LastName, Email)
VALUES ('Trisha', 'Applegate', 'trish@example.com')

UPDATE Contacts
SET FirstName = 'Giorgio'
WHERE Email = 'george@example.com'


ALTER TABLE Contacts
ADD Descr	nvarchar(255) NULL



DECLARE @from_lsn binary(10), @to_lsn binary(10)
SELECT @from_lsn = MIN(__$start_lsn) 
FROM cdc.dbo_Contacts_CT
SELECT @to_lsn = MAX(__$start_lsn) 
FROM cdc.dbo_Contacts_CT
SELECT * FROM cdc.fn_cdc_get_all_changes_dbo_Contacts
	(@from_lsn, @to_lsn, 'all update old');


EXECUTE sys.sp_cdc_get_ddl_history 
@capture_instance = 'dbo_Contacts';



/* 
--sample code to remove change tracking
EXEC sys.sp_cdc_disable_table
	@source_schema='dbo',
	@source_name='Contacts',
	@capture_instance='dbo_Contacts'

EXEC sys.sp_cdc_disable_db
	
*/
