
USE master


CREATE DATABASE Chapter18

use Chapter18


CREATE MESSAGE TYPE OrderMessage
VALIDATION = NONE


CREATE CONTRACT OrderContract
(OrderMessage SENT BY INITIATOR) 


CREATE QUEUE OrderSendQueue

CREATE QUEUE OrderReceiveQueue




CREATE SERVICE OrderSendService
  ON QUEUE OrderSendQueue (OrderContract)

CREATE SERVICE OrderReceiveService
  ON QUEUE OrderReceiveQueue (OrderContract)



DECLARE @OrderDialog uniqueidentifier
DECLARE @Message nvarchar(128)
BEGIN DIALOG CONVERSATION @OrderDialog
  FROM SERVICE OrderSendService
  TO SERVICE 'OrderReceiveService'
  ON CONTRACT OrderContract
  WITH ENCRYPTION = OFF
SET @Message = N'15 boxes of apples';
SEND ON CONVERSATION @OrderDialog
  MESSAGE TYPE OrderMessage (@Message)
SET @Message = N'2 bags of flour';
SEND ON CONVERSATION @OrderDialog
  MESSAGE TYPE OrderMessage (@Message)
SET @Message = N'1 sack of sugar';
SEND ON CONVERSATION @OrderDialog
  MESSAGE TYPE OrderMessage (@Message)



RECEIVE CONVERT(NVARCHAR(max), message_body) AS message
 FROM OrderReceiveQueue




DROP SERVICE OrderReceiveService
GO
DROP QUEUE OrderReceiveQueue
GO



CREATE TABLE Orders
  (OrderID uniqueidentifier,
   OrderText nvarchar(128))




CREATE PROC ReceiveOrder
AS
  DECLARE @message_type_name nvarchar(256)
  DECLARE @message_body nvarchar(128)
  DECLARE @message_id uniqueidentifier

WHILE(1=1)
BEGIN
  WAITFOR (RECEIVE TOP(1)
  @message_type_name = message_type_name,
  @message_body = CONVERT(nvarchar(128), message_body),
  @message_id = message_id
  FROM OrderReceiveQueue), TIMEOUT 200;

  IF (@@ROWCOUNT = 0)
    BREAK

  IF (@message_type_name = 'OrderMessage') 
    INSERT INTO Orders(OrderID, OrderText)
    VALUES(@message_id, @message_body)

END




CREATE QUEUE OrderReceiveQueue
  WITH ACTIVATION (
  PROCEDURE_NAME = dbo.ReceiveOrder,
   MAX_QUEUE_READERS = 5,
   EXECUTE AS SELF)



CREATE SERVICE OrderReceiveService
  ON QUEUE OrderReceiveQueue (OrderContract)



DECLARE @OrderDialog uniqueidentifier
DECLARE @Message nvarchar(128)
BEGIN DIALOG CONVERSATION @OrderDialog
  FROM SERVICE OrderSendService
  TO SERVICE 'OrderReceiveService'
  ON CONTRACT OrderContract
  WITH ENCRYPTION = OFF
SET @Message = N'2 pounds of nails';
SEND ON CONVERSATION @OrderDialog
  MESSAGE TYPE OrderMessage (@Message)
SET @Message = N'1 box of bolts';
SEND ON CONVERSATION @OrderDialog
  MESSAGE TYPE OrderMessage (@Message)
SET @Message = N'3 screen doors';
SEND ON CONVERSATION @OrderDialog
  MESSAGE TYPE OrderMessage (@Message)



SELECT * FROM Orders










