USE Chapter18


CREATE MESSAGE TYPE ReceiptMessage
VALIDATION = NONE


DROP SERVICE OrderSendService
DROP SERVICE OrderReceiveService
DROP CONTRACT OrderContract


CREATE CONTRACT OrderContract
(OrderMessage SENT BY INITIATOR,
 ReceiptMessage SENT BY TARGET)



CREATE SERVICE OrderSendService
  ON QUEUE OrderSendQueue (OrderContract)

CREATE SERVICE OrderReceiveService
  ON QUEUE OrderReceiveQueue (OrderContract)





ALTER PROC ReceiveOrder
AS
  DECLARE @message_type_name nvarchar(256)
  DECLARE @message_body nvarchar(128)
  DECLARE @message_id uniqueidentifier

WHILE(1=1)
BEGIN
  WAITFOR (RECEIVE TOP(1)
  @message_type_name = message_type_name,
  @message_body = CONVERT(nvarchar(128), message_body),
  @message_id = message_id
  FROM OrderReceiveQueue), TIMEOUT 200;

  IF (@@ROWCOUNT = 0)
    BREAK

  IF (@message_type_name = 'OrderMessage') 
    BEGIN
      INSERT INTO Orders(OrderID, OrderText)
        VALUES(@message_id, @message_body)
      DECLARE @ReceiptDialog uniqueidentifier
      DECLARE @Message nvarchar(128)
      BEGIN DIALOG CONVERSATION @ReceiptDialog
        FROM SERVICE OrderReceiveService
        TO SERVICE 'OrderSendService'
        ON CONTRACT OrderContract
        WITH ENCRYPTION = OFF
      SET @Message = N'Thank you for your order';
      SEND ON CONVERSATION @ReceiptDialog
        MESSAGE TYPE OrderMessage (@Message)
    END

END





DECLARE @OrderDialog uniqueidentifier
DECLARE @Message nvarchar(128)
BEGIN DIALOG CONVERSATION @OrderDialog
  FROM SERVICE OrderSendService
  TO SERVICE 'OrderReceiveService'
  ON CONTRACT OrderContract
  WITH ENCRYPTION = OFF
SET @Message = N'A new pony';
SEND ON CONVERSATION @OrderDialog
  MESSAGE TYPE OrderMessage (@Message)





RECEIVE CONVERT(NVARCHAR(max), message_body) AS message
 FROM OrderSendQueue






