
SELECT * FROM Production.ScrapReason;
GO


Print 5*5+5;
Print (5*5)+5;
Print 5*(5+5);
GO


Print @@Servername;
Print @@Servicename;
Print @@Version;
GO


DECLARE @myservername varchar(128);
SET @myservername = @@SERVERNAME;
PRINT @myservername;
GO


PRINT 'Math Functions';
PRINT ABS(3);
PRINT ABS(-3);
PRINT EXP(3);
PRINT LOG(10);
PRINT LOG10(10);
PRINT PI();
PRINT POWER(3,4);
PRINT SQRT(81);
GO




PRINT 'String Functions';
PRINT LEFT(' Some text ', 5);
PRINT LEN(' Some text ');
PRINT LOWER(' Some text ');
PRINT LTRIM(' Some text ');
PRINT RIGHT(' Some text ', 5);
PRINT RTRIM(' Some text ');
PRINT UPPER(' Some text ');
GO




PRINT 'Date Functions';
PRINT GETDATE();
-- For other options to DATEPART(), see Books Online
PRINT DATEPART(yy, GETDATE());
PRINT DATEPART(mm, GETDATE());
PRINT DATEPART(dd, GETDATE());
-- Calculate days between 1/1/2008 and today
PRINT DATEDIFF(dd, '1/1/2008', GETDATE());
PRINT ISDATE('2/28/2008');
PRINT ISDATE('2/31/2008');
GO




DECLARE @ncustomers int;
SET @ncustomers = 5;
PRINT 'There are ' + @ncustomers + ' customers';
GO


DECLARE @ncustomers int;
SET @ncustomers = 5;
PRINT 'There are ' + CAST(@ncustomers AS varchar(5)) + ' customers';
GO




USE master;
CREATE DATABASE Chapter4;
GO

USE Chapter4;
GO

CREATE SCHEMA Production;
GO
CREATE SCHEMA Testing;
GO




CREATE TABLE Testing.Visitor
(
    VisitorID int NOT NULL,
    VisitorIP char(16) NOT NULL,
    VisitDate datetime NOT NULL
)
GO


CREATE TABLE Production.Stats
(
    BytesIn int NOT NULL,
    BytesOut int NOT NULL,
    BytesTotal AS BytesIn + BytesOut
)
GO



CREATE TABLE Testing.Server
(
    ServerID int NOT NULL IDENTITY(1,1),
    ServerName nvarchar(50) NOT NULL,
    DeploymentDate datetime NULL DEFAULT GETDATE()
    CONSTRAINT PK_Server PRIMARY KEY CLUSTERED (ServerID)
)
GO




CREATE TABLE Production.Login
(
    userid nvarchar(50) NOT NULL UNIQUE,
    password nvarchar(50) NOT NULL
)
GO





CREATE TABLE Testing.Software
(
    SoftwareID int NOT NULL IDENTITY (1,1) PRIMARY KEY,
    ServerID int NOT NULL 
        REFERENCES Testing.Server(ServerID),
    PackageName varchar(128) NOT NULL
) 
GO



CREATE INDEX IX_Software_PackageName
  ON Testing.Software (PackageName);
 GO 




ALTER TABLE Testing.Software
  ADD PackageVersion varchar(6) NULL;
GO






