
CREATE DATABASE LibrarySQL;
GO

USE LibrarySQL;
GO


CREATE TABLE Authors
(
    AuthorID int NOT NULL IDENTITY (1,1),
    Name nvarchar(128) NOT NULL,
    Country nvarchar(50) NOT NULL,
    CONSTRAINT PK_Authors PRIMARY KEY (AuthorID),
    CONSTRAINT IX_Author_Name UNIQUE (Name)
);
GO



CREATE TABLE AuthorsBooks
(
    AuthorID int NOT NULL,
    BookID int NOT NULL,
    CONSTRAINT PK_AuthorsBooks PRIMARY KEY 
      (AuthorID, BookID),
    CONSTRAINT FK_AuthorsBooks_Authors 
       FOREIGN KEY (AuthorID)
       REFERENCES Authors (AuthorID)
);
GO



CREATE TABLE Books
(
    BookID int NOT NULL IDENTITY (1,1),
    Title nvarchar(128) NOT NULL,
    Pages smallint NOT NULL,
    CONSTRAINT PK_Books PRIMARY KEY (BookID)
);
GO


ALTER TABLE AuthorsBooks
    ADD CONSTRAINT FK_AuthorsBooks_Books 
       FOREIGN KEY (BookID)
       REFERENCES Books (BookID);
GO
 


ALTER TABLE Books
  ADD CONSTRAINT CK_Pages CHECK (Pages > 0);
GO







