

SELECT * FROM Person.Person;
GO


SELECT Title, Firstname, MiddleName, LastName 
FROM Person.Person
GO


SELECT * FROM Person.Person
GO

SELECT LastName, Title, ModifiedDate
FROM Person.Person
GO


SELECT Title, Firstname AS [First Name], 
  MiddleName AS [Middle Name], 
  LastName AS [Last Name]
FROM Person.Person
GO



SELECT LastName AS [Name],
  Title AS [Salutation], 
  ModifiedDate AS [Last Edited]
FROM Person.Person
GO




SELECT Firstname + ' ' + LastName
  AS FullName
FROM Person.Person
GO


SELECT LEFT(FirstName,1) + '.' +
 LEFT(LastName,1) + '.' AS Initials
FROM Person.Person
GO



SELECT $IDENTITY, $ROWGUID
FROM Person.BusinessEntity
GO


SELECT P.FirstName, P.LastName
FROM Person.Person AS P
GO


SELECT pp.PersonType, pp.FullName FROM
(SELECT FirstName + ' ' + LastName AS FullName,
 PersonType, NameStyle
 FROM Person.Person) AS pp
GO



SELECT pp.LastEdit, pp.SortName FROM
(SELECT LastName + ', ' + FirstName AS SortName,
 ModifiedDate AS LastEdit
 FROM Person.Person) AS pp
GO


SELECT S.Name AS State, C.Name AS Country
FROM Person.StateProvince AS S, Person.CountryRegion AS C
GO


SELECT S.Name AS State, C.Name AS Country
FROM Person.StateProvince AS S
INNER JOIN Person.CountryRegion AS C
ON S.CountryRegionCode = C.CountryRegionCode
GO




SELECT A.City, SP.Name AS State
FROM Person.Address AS A
INNER JOIN Person.StateProvince AS SP
ON A.StateProvinceID = SP.StateProvinceID
GO



SELECT p.BusinessEntityID, p.FirstName, p.LastName,
	a.AddressLine1, a.City, sp.Name AS State,
	cr.Name AS Country
FROM Person.Person AS p
	INNER JOIN Person.BusinessEntity AS be
		ON p.BusinessEntityID = be.BusinessEntityID
	INNER JOIN Person.BusinessEntityAddress AS bea
		ON be.BusinessEntityID = bea.BusinessEntityID
	INNER JOIN Person.Address AS a
		ON bea.AddressID = a.AddressID
	INNER JOIN Person.StateProvince AS sp
		ON a.StateProvinceID = sp.StateProvinceID
	INNER JOIN Person.CountryRegion AS cr
		ON sp.CountryRegionCode = cr.CountryRegionCode
GO




SELECT p.FirstName + ' ' + p.LastName AS FullName,
    t.Name AS Territory, sp.SalesLastYear
FROM Person.Person AS p
  INNER JOIN Sales.SalesPerson AS sp 
    ON p.BusinessEntityID = sp.BusinessEntityID
  INNER JOIN Sales.SalesTerritory AS t
    ON sp.TerritoryID = t.TerritoryID
GO



USE University;
GO

SELECT U.StudentID AS UID, U.StudentName AS UName,
  U.UndergradMajor as UMajor, G.StudentID AS GID,
  G.StudentName AS GName, G.GradMajor AS GMajor
FROM UndergradStudents U 
  INNER JOIN GraduateStudents G
  ON U.StudentID = G.StudentID
GO



SELECT U.StudentID AS UID, U.StudentName AS UName,
  U.UndergradMajor as UMajor, G.StudentID AS GID,
  G.StudentName AS GName, G.GradMajor AS GMajor
FROM UndergradStudents U 
  LEFT OUTER JOIN GraduateStudents G
  ON U.StudentID = G.StudentID
GO



SELECT U.StudentID AS UID, U.StudentName AS UName,
  U.UndergradMajor as UMajor, G.StudentID AS GID,
  G.StudentName AS GName, G.GradMajor AS GMajor
FROM UndergradStudents U 
  RIGHT OUTER JOIN GraduateStudents G
  ON U.StudentID = G.StudentID
GO

SELECT U.StudentID AS UID, U.StudentName AS UName,
  U.UndergradMajor as UMajor, G.StudentID AS GID,
  G.StudentName AS GName, G.GradMajor AS GMajor
FROM UndergradStudents U 
  FULL OUTER JOIN GraduateStudents G
  ON U.StudentID = G.StudentID
GO


SELECT U.StudentID AS UID, U.StudentName AS UName,
  U.UndergradMajor as UMajor, G.StudentID AS GID,
  G.StudentName AS GName, G.GradMajor AS GMajor
FROM UndergradStudents U 
  CROSS JOIN GraduateStudents G
GO


USE AdventureWorks2008
GO



SELECT * FROM Person.Person
WHERE BusinessEntityID = 8233
GO


SELECT * FROM Person.Person
WHERE BusinessEntityID >= 8233
GO



SELECT * FROM Person.Person
WHERE BusinessEntityID = 15000
GO


SELECT * FROM Person.Person
WHERE FirstName = 'Michael'
GO



SELECT * FROM Person.Person
WHERE LastName LIKE 'Q%'
GO


SELECT * FROM Person.Person
WHERE LastName NOT LIKE '[rst]%'
GO



SELECT * FROM Person.Person
WHERE FirstName LIKE 'Ja%'
GO



SELECT * FROM Person.Person
WHERE ModifiedDate = '2004-3-8'
GO


SELECT name, alias FROM sys.syslanguages
GO


SELECT * FROM Person.Person
WHERE ModifiedDate = CONVERT(DATETIME,'20040308',101)
GO


SELECT * FROM Person.Person
WHERE MiddleName IS NULL
GO


SELECT * FROM Person.Person
ORDER BY LastName
GO


SELECT * FROM Person.Person
ORDER BY LastName DESC
GO


SELECT * FROM Person.Person
ORDER BY LastName DESC, FirstName ASC
GO


SELECT Name, StateProvinceCode, CountryRegionCode 
FROM Person.StateProvince
ORDER BY CountryRegionCode, StateProvinceCode
GO



SELECT SUM(OrderQty) AS TotalSales
FROM Sales.SalesOrderDetail
GO


SELECT P.Name, SUM(S.OrderQty) AS ProductSales
FROM Sales.SalesOrderDetail S 
INNER JOIN Production.Product P
ON S.ProductID = P.ProductID
GROUP BY P.Name
ORDER BY P.Name
GO


SELECT DaysToManufacture, MAX(ListPrice) AS MaxPrice
FROM Production.Product
GROUP BY DaysToManufacture
ORDER BY DaysToManufacture DESC
GO


SELECT P.Name, SUM(S.OrderQty) AS ProductSales
FROM Sales.SalesOrderDetail S 
INNER JOIN Production.Product P
ON S.ProductID = P.ProductID
WHERE S.OrderQty >= 5
GROUP BY P.Name
ORDER BY P.Name
GO


SELECT DaysToManufacture, MAX(ListPrice) AS MaxPrice
FROM Production.Product
WHERE ListPrice < 1400
GROUP BY DaysToManufacture
ORDER BY DaysToManufacture DESC
GO


SELECT P.Name, SUM(S.OrderQty) AS ProductSales
FROM Sales.SalesOrderDetail S 
INNER JOIN Production.Product P
ON S.ProductID = P.ProductID
GROUP BY P.Name
HAVING SUM(S.OrderQty) >= 4000
ORDER BY P.Name
GO


SELECT DaysToManufacture, MAX(ListPrice) AS MaxPrice
FROM Production.Product
GROUP BY DaysToManufacture
HAVING MAX(ListPrice) < 1400
ORDER BY DaysToManufacture DESC
GO


SELECT TOP (5) * 
FROM Sales.SalesOrderDetail
ORDER BY OrderQty DESC
GO


SELECT TOP (1) PERCENT * 
FROM Sales.SalesOrderDetail
ORDER BY OrderQty DESC
GO


SELECT TOP (1) PERCENT WITH TIES * 
FROM Sales.SalesOrderDetail
ORDER BY OrderQty DESC
GO


SELECT TOP (10) Name, ListPrice
FROM Production.Product 
ORDER BY ListPrice DESC
GO


SELECT TOP (1) PERCENT Name, ListPrice
FROM Production.Product 
ORDER BY ListPrice DESC
GO


SELECT TOP (1) PERCENT WITH TIES Name, ListPrice
FROM Production.Product 
ORDER BY ListPrice DESC
GO


SELECT * FROM Production.Product
WHERE ProductID = 316
GO


SELECT * FROM Production.Product
WHERE ProductID = 320
GO


SELECT * FROM Production.Product
WHERE ProductID = 316
UNION
SELECT * FROM Production.Product
WHERE ProductID = 320
GO


SELECT v.Name AS Vendor, h.OrderDate, h.TotalDue
FROM Purchasing.Vendor AS v
INNER JOIN Purchasing.PurchaseOrderHeader AS h
ON v.BusinessEntityID = h.VendorID
WHERE h.OrderDate BETWEEN '1/1/2002' AND '12/31/2002'
GO

SELECT p.FirstName, p.LastName, h.OrderDate, h.TotalDue
FROM Person.Person AS p
INNER JOIN Sales.Customer AS c 
ON p.BusinessEntityID = c.PersonID
INNER JOIN Sales.SalesOrderHeader AS h
ON c.CustomerID = h.CustomerID
WHERE h.OrderDate BETWEEN '1/1/2002' AND '12/31/2002'
GO



SELECT v.Name, h.OrderDate, -1 * h.TotalDue AS Amount,
'Purchase' AS TransactionType
FROM Purchasing.Vendor AS v
INNER JOIN Purchasing.PurchaseOrderHeader AS h
ON v.BusinessEntityID = h.VendorID
WHERE h.OrderDate BETWEEN '1/1/2002' AND '12/31/2002'
UNION ALL
SELECT p.FirstName + ' ' + p.LastName AS Name, 
h.OrderDate, h.TotalDue, 'Sale' AS TransType
FROM Person.Person AS p
INNER JOIN Sales.Customer AS c 
ON p.BusinessEntityID = c.PersonID
INNER JOIN Sales.SalesOrderHeader AS h
ON c.CustomerID = h.CustomerID
WHERE h.OrderDate BETWEEN '1/1/2002' AND '12/31/2002'
GO


SELECT BusinessEntityID, FirstName, LastName 
FROM Person.Person
WHERE BusinessEntityID = 7879
UNION
SELECT BusinessEntityID, FirstName, LastName 
FROM Person.Person
WHERE BusinessEntityID = 8758
UNION
SELECT BusinessEntityID, FirstName, LastName 
FROM Person.Person
WHERE BusinessEntityID = 16916
GO


SELECT * FROM Production.ProductDescription
GO


SELECT *
FROM Production.ProductDescription
WHERE FREETEXT (Description, 'easy')
GO


SELECT *
FROM Production.ProductDescription
WHERE CONTAINS (Description, 'Aluminum')
GO


SELECT *
FROM Production.ProductDescription
WHERE CONTAINS (Description, '"comfort*"')
GO


SELECT *
FROM Production.ProductDescription
WHERE CONTAINS(Description, 
'FORMSOF (INFLECTIONAL, design)')
GO


SELECT *
FROM Production.ProductDescription
WHERE CONTAINS(Description, 'style NEAR comfort')
GO


SELECT *
FROM Production.ProductDescription
WHERE CONTAINS(Description, 'ISABOUT (comfort weight(.8), 
smooth weight(.4), style weight(.2))')
GO

