
SELECT * FROM Person.vStateProvinceCountryRegion




CREATE VIEW Production.vInventoryByLocation
AS
SELECT P.Name AS Product, L.Name AS InventoryLocation,
    SUM(PI.Quantity)AS QtyAvailable
FROM Production.Product AS P
    JOIN Production.ProductInventory AS PI ON P.ProductID = PI.ProductID
    JOIN Production.Location AS L ON PI.LocationID = L.LocationID
GROUP BY P.Name, L.Name 


SELECT * FROM Production.vInventoryByLocation
ORDER BY Product, InventoryLocation



UPDATE Production.vLargePurchaseOrder
SET CreditRating = 2
WHERE Name = 'American Bikes'


UPDATE Production.vLargePurchaseOrder
SET CreditRating = 2, OrderDate = '6/1/2001'
WHERE PurchaseOrderID = 6



UPDATE Production.vLargePurchaseOrder
SET CreditRating = 2
WHERE Name = 'Crowley Sport'


SELECT * FROM INFORMATION_SCHEMA.SCHEMATA

SELECT * FROM sys.objects


SELECT * FROM sys.objects
WHERE type = 'U'
ORDER BY name


SELECT * FROM sys.objects
WHERE type = 'U' AND schema_id = SCHEMA_ID('Sales')
ORDER BY name




CREATE PROC Person.uspAllContacts
AS
SELECT * FROM Person.Person


Person.uspAllContacts



CREATE PROC Production.uspSelectedProducts
  @Color nvarchar(15) = 'Black',
  @ListPrice money = 0
AS
  SELECT * 
  FROM Production.Product
  WHERE Color = @Color AND ListPrice = @ListPrice


Production.uspSelectedProducts


EXEC Production.uspSelectedProducts DEFAULT, DEFAULT


EXEC Production.uspSelectedProducts @Color='Silver'


EXEC Production.uspSelectedProducts @Color='Red',
  @ListPrice=1431.50


EXEC Production.uspSelectedProducts @ListPrice=1431.50,
   @Color='Red'



CREATE PROC Production.uspSelectProductsByColor
  @Color nvarchar(15) = 'All'
AS
  IF @Color = 'All'
    SELECT *
    FROM Production.Product
  ELSE
    SELECT * 
    FROM Production.Product
    WHERE Color = @Color


EXEC Production.uspSelectProductsByColor 'All'


EXEC Production.uspSelectProductsByColor 'Blue'



CREATE PROC Production.uspSelectProductsByColorWithCount
  @Color nvarchar(15) = 'All'
AS
  DECLARE @NumProducts int
  IF @Color = 'All'
    BEGIN
      SELECT *
        FROM Production.Product
      SELECT @NumProducts = COUNT(*)
        FROM Production.Product
      PRINT 'Total Products = ' + 
        CAST(@NumProducts AS varchar(5))
    END
  ELSE
    BEGIN
      SELECT * 
        FROM Production.Product
        WHERE Color = @Color
      SELECT @NumProducts = COUNT(*)
        FROM Production.Product
        WHERE Color = @Color
      PRINT 'Matching Products = ' + 
        CAST(@NumProducts AS varchar(5))
    END


EXEC Production.uspSelectProductsByColorWithCount 'All'


EXEC Production.uspSelectProductsByColorWithCount 'Blue'



CREATE PROC
 Production.uspSelectProductsByColorWithReturnedCount
  @Color nvarchar(15) = 'All'
AS
  DECLARE @NumProducts int
  IF @Color = 'All'
    BEGIN
      SELECT *
        FROM Production.Product
      SELECT @NumProducts = COUNT(*)
        FROM Production.Product
      RETURN @NumProducts
    END
  ELSE
    BEGIN
      SELECT * 
        FROM Production.Product
        WHERE Color = @Color
      SELECT @NumProducts = COUNT(*)
        FROM Production.Product
        WHERE Color = @Color
      RETURN @NumProducts
    END


DECLARE @Count int
EXEC @Count = 
Production.uspSelectProductsByColorWithReturnedCount 'All'
PRINT @Count


DECLARE @Count int
EXEC @Count = 
Production.uspSelectProductsByColorWithReturnedCount 'Blue'
PRINT @Count



CREATE PROC Person.uspGetNameByContactID
  @BusinessEntityID int,
  @FirstName nvarchar(50) OUT,
  @MiddleName nvarchar(50) OUT,
  @LastName nvarchar(50) OUT
AS
  SELECT @FirstName = FirstName,
    @MiddleName = MiddleName,
    @LastName = LastName
  FROM Person.Person
  WHERE BusinessEntityID = @BusinessEntityID


SELECT dbo.ufnLeadingZeros(123)



CREATE FUNCTION dbo.ufnGetDateOnly
  (@FullDate datetime)
RETURNS varchar(10)
AS
BEGIN
  RETURN (CONVERT(varchar(10),@FullDate,101))
END


SELECT GETDATE(), dbo.ufnGetDateOnly(GETDATE())



CREATE FUNCTION Production.ufnProductsByColor
  (@Color nvarchar(15))
RETURNS TABLE
AS
RETURN
(
  SELECT *
  FROM Production.Product
  WHERE Color = @Color
)


SELECT * FROM Production.ufnProductsByColor('Silver')









