
CREATE VIEW Production.vProductInfo
AS
SELECT ProductID, Name, Color, ListPrice, Size 
FROM Production.Product



CREATE PROC Person.uspAllLocations
AS
SELECT * FROM Production.Location



CREATE PROC Production.uspLocationDetails
  @LocationID int
AS
  SELECT * 
  FROM Production.Location
  WHERE LocationID = @LocationID



CREATE PROC Production.uspReturnLocationType
  @LocationID int
AS
  DECLARE @CostRate smallmoney
  SELECT @CostRate = CostRate 
    FROM Production.Location
    WHERE Location.LocationID = @LocationID
  IF @CostRate = 0
    RETURN 0
  ELSE
    RETURN 1





CREATE PROC Production.uspOutputLocationType
  @LocationID int,
  @LocationType varchar(7) OUT
AS
  DECLARE @CostRate smallmoney
  SELECT @CostRate = CostRate 
    FROM Production.Location
    WHERE Location.LocationID = @LocationID
  IF @CostRate = 0
    SET @LocationType = 'FREE'
  ELSE
    SET @LocationType = 'CHARGED'




CREATE FUNCTION dbo.ufnGetTimeOnly
  (@FullDate datetime)
RETURNS varchar(10)
AS
BEGIN
  RETURN (CONVERT(char(8),@FullDate,108))
END



CREATE FUNCTION Production.ufnProductsBySize
  (@Size nvarchar(5))
RETURNS TABLE
AS
RETURN
(
  SELECT *
  FROM Production.Product
  WHERE Size = @Size
)







