

SELECT * FROM Production.Location 
WHERE LocationID = 40
BEGIN TRANSACTION
  UPDATE Production.Location
    SET Name = 'Painting' 
    WHERE LocationID = 40
  SELECT * FROM Production.Location 
    WHERE LocationID = 40
ROLLBACK TRANSACTION
SELECT * FROM Production.Location 
WHERE LocationID = 40




SELECT * FROM Production.Location 
WHERE LocationID = 40
BEGIN TRANSACTION Trans1
  BEGIN TRANSACTION Trans2
    UPDATE Production.Location
      SET Name = 'Painting' 
      WHERE LocationID = 40
    SELECT * FROM Production.Location 
      WHERE LocationID = 40
  COMMIT TRANSACTION Trans2
  SELECT * FROM Production.Location 
    WHERE LocationID = 40
ROLLBACK TRANSACTION Trans1
SELECT * FROM Production.Location 
WHERE LocationID = 40




SELECT * FROM Production.Location 
WHERE LocationID = 40
BEGIN TRANSACTION
  UPDATE Production.Location
    SET Name = 'Painting' 
    WHERE LocationID = 40
  SAVE TRANSACTION SavedTrans
  UPDATE Production.Location
    SET Name = 'Coloring' 
    WHERE LocationID = 40
  SELECT * FROM Production.Location 
  WHERE LocationID = 40
ROLLBACK TRANSACTION SavedTrans
COMMIT TRANSACTION
SELECT * FROM Production.Location 
WHERE LocationID = 40



/*
Example stored procedure invokation to create a linked server,
in case UI methods fail
sp_addlinkedserver 'CHAPTER9', 'Access', 'Microsoft.Jet.OLEDB.4.0', 
   'C:\Accelebrate\sql2008\Chapter 9\Chapter9.mdb'
*/

SELECT * FROM
OPENQUERY(CHAPTER9, 'SELECT * FROM Material')


SELECT * FROM
OPENROWSET('Microsoft.Jet.OLEDB.4.0',
  'C:\Accelebrate\sql2008\Chapter 9\Chapter9.mdb';
  'admin';'','SELECT * FROM Material')




SELECT c.FirstName, c.LastName,
ROW_NUMBER() OVER(ORDER BY SalesYTD DESC) 
AS 'Row Number', s.SalesYTD
FROM Sales.SalesPerson s 
INNER JOIN Person.Person c 
ON s.BusinessEntityID = c.BusinessEntityID
WHERE TerritoryID IS NOT NULL 
AND SalesYTD <> 0
ORDER BY SalesYTD DESC



SELECT p.Name AS ProductName, 
SUM(d.OrderQty) AS TotalQuantity,
RANK() OVER(ORDER BY SUM(d.OrderQty) DESC)
AS ProductRank
FROM Production.Product p
INNER JOIN Sales.SalesOrderDetail d
ON p.ProductID = d.ProductID
INNER JOIN Sales.SalesOrderHeader h
ON d.SalesOrderID = h.SalesOrderID
WHERE h.OrderDate BETWEEN '1/1/2002' AND '12/31/2002'
GROUP BY p.Name
ORDER BY TotalQuantity DESC




SELECT p.Name AS ProductName, 
SUM(d.OrderQty) AS TotalQuantity,
DENSE_RANK() OVER(ORDER BY SUM(d.OrderQty) DESC)
AS ProductRank
FROM Production.Product p
INNER JOIN Sales.SalesOrderDetail d
ON p.ProductID = d.ProductID
INNER JOIN Sales.SalesOrderHeader h
ON d.SalesOrderID = h.SalesOrderID
WHERE h.OrderDate BETWEEN '1/1/2002' AND '12/31/2002'
GROUP BY p.Name
ORDER BY TotalQuantity DESC



SELECT p.FirstName, p.LastName, 
SUM(h.TotalDue) AS Purchases,
NTILE(100) OVER (ORDER BY SUM(h.TotalDue)) AS CustPercent
FROM Person.Person AS p
INNER JOIN Sales.Customer AS c 
ON p.BusinessEntityID = c.PersonID
INNER JOIN Sales.SalesOrderHeader AS h
ON c.CustomerID = h.CustomerID
WHERE h.OrderDate BETWEEN '1/1/2002' AND '3/31/2002'
GROUP BY p.FirstName, p.LastName



SELECT SalesOrderID, ProductID, OrderQty,
SUM(OrderQty) OVER(PARTITION BY SalesOrderID) AS 'Total',
AVG(OrderQty) OVER(PARTITION BY SalesOrderID) AS 'Avg',
COUNT(OrderQty) OVER(PARTITION BY SalesOrderID) AS 'Count',
MIN(OrderQty) OVER(PARTITION BY SalesOrderID) AS 'Min',
MAX(OrderQty) OVER(PARTITION BY SalesOrderID) AS 'Max'
FROM Sales.SalesOrderDetail 
WHERE SalesOrderID IN(43659,43664)




DECLARE @productid int, @productname nvarchar(50)
DECLARE product_cursor CURSOR
 LOCAL SCROLL STATIC
 FOR
  SELECT ProductID, Name 
  FROM Production.Product
  ORDER BY Name
OPEN product_cursor
PRINT 'Product List'
Print ''
FETCH NEXT FROM product_cursor
 INTO @productid, @productname
PRINT CAST(@productid AS nvarchar(5)) + ' ' + @productname
WHILE @@FETCH_STATUS = 0
 BEGIN
  FETCH NEXT FROM product_cursor
   INTO @productid, @productname
  PRINT CAST(@productid AS nvarchar(5)) + ' ' + @productname
 END
CLOSE product_cursor
DEALLOCATE product_cursor



BEGIN TRY
  DELETE FROM Production.Product
  WHERE ProductID = 341
END TRY
BEGIN CATCH
  PRINT 'An error occurred'
END CATCH


BEGIN TRY
  DELETE FROM Production.Product
  WHERE ProductID = 341
END TRY
BEGIN CATCH
  SELECT 
    ERROR_NUMBER() AS ErrorNumber,
    ERROR_SEVERITY() AS ErrorSeverity,
    ERROR_STATE() as ErrorState,
    ERROR_PROCEDURE() as ErrorProcedure,
    ERROR_LINE() as ErrorLine,
    ERROR_MESSAGE() as ErrorMessage
END CATCH










