
CREATE PROC Production.uspDeleteProduct
  @ProductID int
AS
BEGIN TRY
    BEGIN TRANSACTION
    DELETE FROM Production.Product
        WHERE ProductID = @ProductID
    -- If the delete succeeds, commit the transaction
    COMMIT TRANSACTION
END TRY
BEGIN CATCH
  SELECT 
    ERROR_NUMBER() AS ErrorNumber,
    ERROR_SEVERITY() AS ErrorSeverity,
    ERROR_STATE() as ErrorState,
    ERROR_PROCEDURE() as ErrorProcedure,
    ERROR_LINE() as ErrorLine,
    ERROR_MESSAGE() as ErrorMessage
    -- If any error, rollback the transaction
    ROLLBACK TRANSACTION
END CATCH



SELECT L.Name, LS.BuildingName 
FROM Production.Location AS L LEFT OUTER JOIN
OPENROWSET('Microsoft.Jet.OLEDB.4.0',
  'C:\Accelebrate\sql2008\Chapter 9\Chapter9.mdb';
  'admin';'','SELECT * FROM LocationSupplement') AS LS
ON L.LocationID = LS.LocationID



SELECT SalesOrderID, TotalDue,
RANK() OVER (ORDER BY TotalDue DESC) AS SalesRank
FROM Sales.SalesOrderHeader
ORDER BY TotalDue DESC


SELECT SalesOrderID, TotalDue,
NTILE(100) OVER (ORDER BY TotalDue DESC) AS SalesRank
FROM Sales.SalesOrderHeader
ORDER BY TotalDue DESC




DECLARE @salesorderid int, @totaldue money, @countrows int
DECLARE salesorderheader_cursor CURSOR
 LOCAL SCROLL STATIC
 FOR
  SELECT SalesOrderID, TotalDue
  FROM Sales.SalesOrderHeader
  WHERE TotalDue > 15000
  ORDER BY TotalDue
OPEN salesorderheader_cursor
PRINT 'Large Sales'
Print ''
FETCH NEXT FROM salesorderheader_cursor
 INTO @salesorderid, @totaldue
SELECT @countrows = COUNT(*)
  FROM Sales.SalesOrderDetail
  WHERE SalesOrderID = @salesorderid
PRINT CAST(@salesorderid AS varchar(6)) + ' has ' + 
 CAST(@countrows AS varchar(3)) + ' detail lines'
WHILE @@FETCH_STATUS = 0
 BEGIN
  FETCH NEXT FROM salesorderheader_cursor
   INTO @salesorderid, @totaldue
  SELECT @countrows = COUNT(*)
    FROM Sales.SalesOrderDetail
    WHERE SalesOrderID = @salesorderid
  PRINT CAST(@salesorderid AS varchar(6)) + ' has ' + 
   CAST(@countrows AS varchar(3)) + ' detail lines'
 END
CLOSE salesorderheader_cursor
DEALLOCATE salesorderheader_cursor






