﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.SqlServer.Management.Common;
using Microsoft.SqlServer.Management.Smo;

namespace CreateObjects
{
	public partial class Create : Form
	{
		public Create()
		{
			InitializeComponent();
		}

		private void buttonCreate_Click(object sender, EventArgs e)
		{
			// Connect to the server
			Server srv = new Server();
			// Define the database
			Database db = new Database(srv, "Chapter13Exercise");
			// Create the database
			db.Create();
			// Define the table
			Table tb = new Table(db, "Stock");
			// Add columns to the table
			Column c1 = new Column(tb, "StockID", DataType.Int);
			c1.Identity = true;
			c1.Nullable = false;
			tb.Columns.Add(c1);
			Column c2 = new Column(tb, "ProductID", DataType.Int);
			c2.Nullable = false;
			tb.Columns.Add(c2);
			Column c3 = new Column(tb, "RestockLevel", DataType.Int);
			c3.Nullable = false;
			tb.Columns.Add(c3);
			Column c4 = new Column(tb, "Notes", DataType.NVarChar(128));
			c4.Nullable = true;
			tb.Columns.Add(c4);
			// Create the table
			tb.Create();
			// Define the view
			Microsoft.SqlServer.Management.Smo.View vw =
				new Microsoft.SqlServer.Management.Smo.View(db,
				"vwStockLevel");
			// Set the view properties
			vw.TextHeader = "CREATE VIEW vwStockLevel AS";
			vw.TextBody =
				"SELECT StockID, RestockLevel FROM Stock";
			// Create the view
			vw.Create();
			MessageBox.Show("Done");
		}
	}
}
