﻿using System;
using System.Collections;
using System.Data.Sql;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;

namespace Financials
{
	public class TaxLine
	{
		public double BaseAmount;
		public double TaxAmount;
	}

	public class TaxTable
	{
		// Return a table of ten rows
		// The first column of each row is the base amount
		// The second column is the tax amount
		[SqlFunction(FillRowMethodName = "FillRow")]
		public static IEnumerable GetTaxTable()
		{
			TaxLine[] TaxArray = new TaxLine[10];
			for (int i = 0; i <= 9; i++)
			{
				TaxArray[i] = new TaxLine();
				TaxArray[i].BaseAmount = i;
				TaxArray[i].TaxAmount = i * 0.085;
			}
			return (TaxArray);
		}

		// Interpret one row from the returned 
		// array into SQL columns
		public static void FillRow(Object obj,
			out SqlDouble BaseAmount,
			out SqlDouble TaxAmount)
		{
			TaxLine TaxEntry = (TaxLine)obj;
			BaseAmount = TaxEntry.BaseAmount;
			TaxAmount = TaxEntry.TaxAmount;
		}
	}
}
