﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.SqlServer.Management.Common;
using Microsoft.SqlServer.Management.Smo;

namespace ServerManager
{
	public partial class ScriptTable : Form
	{
		private Server srv;

		public ScriptTable()
		{
			InitializeComponent();
		}

		private void buttonGetTables_Click(object sender, EventArgs e)
		{
			// Get the list of tables in the database
			Database db = srv.Databases[textBoxDatabase.Text];
			foreach (Table tb in db.Tables)
				listBoxTables.Items.Add(tb.Schema + "." + tb.Name);
		}

		private void ScriptTable_Load(object sender, EventArgs e)
		{
			srv = new Server();
		}

		private void listBoxTables_SelectedIndexChanged(object sender, EventArgs e)
		{
			textBoxScript.Clear();
			// Get the selected table
			Database db = srv.Databases[textBoxDatabase.Text];
			string tname = listBoxTables.SelectedItem.ToString();
			string[] names = tname.Split('.');
			Table tb = db.Tables[names[1], names[0]];
			StringCollection sc = tb.Script();
			StringEnumerator en = sc.GetEnumerator();
			while (en.MoveNext())
				textBoxScript.Text += en.Current + " ";
		}

	}
}
