﻿using System;
using System.Data;
using System.Data.Sql;
using System.Data.SqlClient;
using Microsoft.SqlServer.Server;
using System.Data.SqlTypes;

namespace Strings
{
	public class StringTable
	{
		[SqlProcedure()]
		public static void StringToTable(string InString)
		{
			// Get the pipe back to the hosting database
			SqlPipe sp = SqlContext.Pipe;

			// Define the column schema
			SqlMetaData[] colschema = new SqlMetaData[]{
                new SqlMetaData("ID", SqlDbType.Int),
                new SqlMetaData("Letter",
                    SqlDbType.NVarChar,1)};

			// Construct and send records
			SqlDataRecord newrec = new SqlDataRecord(colschema);
			// First record just sets up the metadata
			newrec.SetSqlInt32(0, 1);
			newrec.SetSqlString(1, Convert.ToString('x'));
			sp.SendResultsStart(newrec);
			for (int i = 0; i < InString.Length; i++)
			{
				newrec.SetSqlInt32(0, i + 1);
				newrec.SetSqlString(1,
					Convert.ToString(InString[i]));
				sp.SendResultsRow(newrec);
			}
			// Tell the server we're all done
			sp.SendResultsEnd();
		}
	}
}
